// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIBase.pas' rev: 4.00

#ifndef SMIBaseHPP
#define SMIBaseHPP

#pragma delphiheader begin
#pragma option push -w-
#include <SMIStat.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Buttons.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smibase
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTableTypeImport { teParadox, teDBase, teText, teHTML, teXLS, teWKS, teQuattro, teXML, teAccess, 
	teWord, teADO, teSPSS };
#pragma option pop

typedef Set<TTableTypeImport, teParadox, teSPSS>  TImportFormatTypes;

#pragma option push -b-
enum TSMICharacterSet { csiANSI_WINDOWS, csiASCII_MSDOS };
#pragma option pop

#pragma option push -b-
enum TImportMode { imAppend, imUpdate, imAppendUpdate, imDelete, imCopy };
#pragma option pop

typedef Set<TImportMode, imAppend, imCopy>  TImportModes;

#pragma option push -b-
enum TSMIAction { iaUnknown, iaAdd, iaUpdate, iaDelete };
#pragma option pop

#pragma option push -b-
enum TSMIResult { irUnknown, irExecuted, irCanceled, irFailed };
#pragma option pop

#pragma option push -b-
enum TSMIFieldDelimiter { fdNone, fdCustom, fdTab, fdSemicolon, fdComma, fdSpace };
#pragma option pop

#pragma option push -b-
enum TSMITextQualifier { tqNone, tqCustom, tqQuot, tqApos };
#pragma option pop

#pragma option push -b-
enum TSMIRecordSeparator { rsCustom, rsCRLF, rsCR, rsLF };
#pragma option pop

typedef AnsiString TSMIAbout;

#pragma option push -b-
enum TSMIOption { soShowMessage, soExtendedStatistic, soSkipEmptyRow, soUseAnimatedControl, soWaitCursor 
	};
#pragma option pop

typedef Set<TSMIOption, soShowMessage, soWaitCursor>  TSMIOptions;

typedef void __fastcall (__closure *TBeforeRecordEvent)(System::TObject* Sender, const AnsiString Fields
	, Variant &Values, bool &Accept);

typedef void __fastcall (__closure *TAfterRecordEvent)(System::TObject* Sender, bool &Abort);

typedef void __fastcall (__closure *TLocateRecordEvent)(System::TObject* Sender, const AnsiString KeyFields
	, const Variant &Values, bool &Exist, bool &ExecuteLocate);

typedef void __fastcall (__closure *TBeforeFieldEvent)(System::TObject* Sender, Db::TField* Field, const 
	Variant &Values, bool &Accept);

typedef void __fastcall (__closure *TGetCellParamsEvent)(System::TObject* Sender, Db::TField* Field, 
	Variant &Value);

typedef void __fastcall (__closure *TErrorEvent)(System::TObject* Sender, Sysutils::Exception* Error
	, bool &Abort);

class DELPHICLASS TSMIStatistic;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMIStatistic : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FTotalCount;
	int FTotalImported;
	int FTotalAdded;
	int FTotalDeleted;
	int FTotalUpdated;
	int FTotalErrors;
	int FUpdateStep;
	TSMIAction FLastAction;
	TSMIResult FResult;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int TotalCount = {read=FTotalCount, write=FTotalCount, nodefault};
	__property int TotalImported = {read=FTotalImported, write=FTotalImported, stored=false, nodefault}
		;
	__property int TotalAdded = {read=FTotalAdded, write=FTotalAdded, stored=false, nodefault};
	__property int TotalDeleted = {read=FTotalDeleted, write=FTotalDeleted, stored=false, nodefault};
	__property int TotalUpdated = {read=FTotalUpdated, write=FTotalUpdated, stored=false, nodefault};
	__property int TotalErrors = {read=FTotalErrors, write=FTotalErrors, stored=false, nodefault};
	__property int UpdateStep = {read=FUpdateStep, write=FUpdateStep, default=1};
	__property TSMIAction LastAction = {read=FLastAction, write=FLastAction, stored=false, nodefault};
	__property TSMIResult Result = {read=FResult, write=FResult, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMIStatistic(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMIStatistic(void) : Classes::TPersistent() { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma option push -b-
enum TSMIDateOrder { doMDY, doDMY, doYMD, doYDM, doDYM, doMYD };
#pragma option pop

class DELPHICLASS TSMIDataFormats;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMIDataFormats : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TSMIDateOrder FDateOrder;
	char FDateSeparator;
	char FTimeSeparator;
	bool FFourDigitYear;
	bool FLeadingZerosInDate;
	char FThousandSeparator;
	char FDecimalSeparator;
	AnsiString FCurrencyString;
	AnsiString FCustomDateTimeFormat;
	AnsiString FBooleanTrue;
	AnsiString FBooleanFalse;
	bool FUseRegionalSettings;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall LoadRegionalSettings(void);
	
__published:
	__property TSMIDateOrder DateOrder = {read=FDateOrder, write=FDateOrder, default=0};
	__property char DateSeparator = {read=FDateSeparator, write=FDateSeparator, nodefault};
	__property char TimeSeparator = {read=FTimeSeparator, write=FTimeSeparator, nodefault};
	__property bool FourDigitYear = {read=FFourDigitYear, write=FFourDigitYear, nodefault};
	__property bool LeadingZerosInDate = {read=FLeadingZerosInDate, write=FLeadingZerosInDate, nodefault
		};
	__property AnsiString CustomDateTimeFormat = {read=FCustomDateTimeFormat, write=FCustomDateTimeFormat
		};
	__property char ThousandSeparator = {read=FThousandSeparator, write=FThousandSeparator, nodefault};
		
	__property char DecimalSeparator = {read=FDecimalSeparator, write=FDecimalSeparator, nodefault};
	__property AnsiString CurrencyString = {read=FCurrencyString, write=FCurrencyString};
	__property AnsiString BooleanTrue = {read=FBooleanTrue, write=FBooleanTrue};
	__property AnsiString BooleanFalse = {read=FBooleanFalse, write=FBooleanFalse};
	__property bool UseRegionalSettings = {read=FUseRegionalSettings, write=FUseRegionalSettings, nodefault
		};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMIDataFormats(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMIDataFormats(void) : Classes::TPersistent() { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma option push -b-
enum TSMIDataType { itString, itInteger, itFloat, itDateTime, itDate, itTime, itBoolean };
#pragma option pop

class DELPHICLASS TSMIColumn;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMIColumn : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FFieldName;
	AnsiString FCaption;
	TSMIDataType FDataType;
	int FSize;
	int FPrecision;
	Classes::TAlignment FAlignment;
	
public:
	__fastcall virtual TSMIColumn(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, default=0};
	__property AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property TSMIDataType DataType = {read=FDataType, write=FDataType, default=0};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property int Precision = {read=FPrecision, write=FPrecision, nodefault};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TSMIColumn(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TSMIColumns;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMIColumns : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMIControl;
	TSMIColumn* __fastcall GetColumn(int Index);
	void __fastcall SetColumn(int Index, TSMIColumn* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMIColumns(Classes::TComponent* SMICntrl);
	HIDESBASE TSMIColumn* __fastcall Add(void);
	__property TSMIColumn* Items[int Index] = {read=GetColumn, write=SetColumn/*, default*/};
	__property Classes::TComponent* SMIControl = {read=FSMIControl};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMIColumns(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TSMILoadCondition;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMILoadCondition : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FLoadWhen;
	AnsiString FSkipIf;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString LoadWhen = {read=FLoadWhen, write=FLoadWhen};
	__property AnsiString SkipIf = {read=FSkipIf, write=FSkipIf};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMILoadCondition(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMILoadCondition(void) : Classes::TPersistent() { }
	#pragma option pop
	
};

#pragma pack(pop)

typedef void __fastcall (__closure *TSMIOnCreateStructure)(System::TObject* Sender, TSMIColumns* Columns
	);

typedef void __fastcall (__closure *TSMISpecificationEvent)(System::TObject* Sender, AnsiString &AFileName
	);

#pragma option push -b-
enum TSMITrimSpaces { tsNoTrim, tsTrimRight, tsTrimLeft, tsTrimLeftRight };
#pragma option pop

class DELPHICLASS TSMImportBaseComponent;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TSMImportBaseComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FAbout;
	bool FAnimatedStatus;
	bool FAbortOnProblem;
	Db::TDataSet* FDataSet;
	AnsiString FDatasetKeys;
	Classes::TStrings* FMappings;
	TImportMode FMode;
	TSMILoadCondition* FLoadCondition;
	TSMIOptions FOptions;
	AnsiString FTitleStatus;
	TSMIFieldDelimiter FFieldDelimiter;
	char FFieldDelimiterCustom;
	TSMITextQualifier FTextQualifier;
	char FTextQualifierCustom;
	TSMIRecordSeparator FRecordSeparator;
	AnsiString FRecordSeparatorCustom;
	bool FFixed;
	AnsiString FSourceFileName;
	int FRowFirst;
	int FRowLast;
	int FRowFieldNames;
	TSMICharacterSet FCharacterSet;
	TSMIDataFormats* FDataFormats;
	TTableTypeImport FTableType;
	TSMITrimSpaces FTrimSpaces;
	TErrorEvent FOnErrorEvent;
	TGetCellParamsEvent FOnGetCellParams;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	TBeforeRecordEvent FOnBeforeRecordEvent;
	TAfterRecordEvent FOnAfterRecordEvent;
	Classes::TNotifyEvent FOnBeforeUpdate;
	TBeforeFieldEvent FOnBeforeFieldUpdate;
	TSMISpecificationEvent FOnBeforeLoadSpecification;
	TSMISpecificationEvent FOnAfterLoadSpecification;
	TSMISpecificationEvent FOnBeforeSaveSpecification;
	TSMISpecificationEvent FOnAfterSaveSpecification;
	TLocateRecordEvent FOnLocateRecord;
	AnsiString FSpecificationDir;
	bool Abort;
	TSMIStatistic* FStatistic;
	bool FUseDisplayNames;
	TSMIColumns* FColumns;
	TSMIOnCreateStructure FOnCreateStructure;
	TSMIColumns* __fastcall GetColumns(void);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	void __fastcall SetMappings(Classes::TStrings* AValue);
	void __fastcall SetAbout(const AnsiString Value);
	void __fastcall SetLoadCondition(TSMILoadCondition* Value);
	AnsiString __fastcall Translate(const AnsiString s, bool IsEncrypt);
	
protected:
	Variant vLocate;
	Variant vValues;
	Variant vFields;
	int intCurrentParsedFieldIndex;
	Classes::TStream* DataStream;
	Smistat::TfrmSMIProcess* frmSMIProcess;
	bool __fastcall CreateProgressDlg(AnsiString strCaption, AnsiString strMessage, AnsiString strBtnCaption
		, AnsiString strProcessed, AnsiString strErrors, AnsiString strAdded, AnsiString strUpdated, AnsiString 
		strDeleted, bool ShowAnimated, bool ShowExtendedInfo);
	void __fastcall ChangeProgressDlg(int MinValue, int MaxValue, int Progress);
	bool __fastcall DestroyProgressDlg(void);
	bool __fastcall UpdateProgressDlg(AnsiString strMessage, int Progress, int intErrors, int intAdded, 
		int intDeleted, int intUpdated);
	bool __fastcall ProgressCanceled(void);
	int __fastcall GetFieldItem(const AnsiString FieldName);
	AnsiString __fastcall GetTableName();
	bool __fastcall IsGoodRow(int i);
	virtual void __fastcall Prepare(void);
	virtual void __fastcall BeforeImport(void);
	virtual void __fastcall AfterImport(void);
	virtual void __fastcall BuildArrayIntersection(void);
	virtual void __fastcall BuildFieldMapping(void);
	virtual bool __fastcall LoadRecord(void);
	virtual void __fastcall GoFirst(void);
	virtual void __fastcall GoNext(void);
	virtual bool __fastcall NeedMore(void);
	virtual int __fastcall GetTotalCount(void);
	virtual Variant __fastcall GetValues(const AnsiString strValues);
	virtual Variant __fastcall GetFieldValue(const Variant &v);
	virtual Variant __fastcall GetParsedValue(const Variant &v, int intFieldIndex);
	virtual bool __fastcall FieldIsTruncated(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual bool __fastcall NotDefined(AnsiString &strProperty);
	AnsiString __fastcall GetKeyList(Db::TDataSet* DS);
	void __fastcall FillKey4Locate(void);
	void __fastcall FillKey4Values(void);
	void __fastcall SetFieldDelimiter(TSMIFieldDelimiter Value);
	void __fastcall SetFieldDelimiterCustom(char Value);
	void __fastcall SetTextQualifier(TSMITextQualifier Value);
	void __fastcall SetTextQualifierCustom(char Value);
	void __fastcall SetRecordSeparator(TSMIRecordSeparator Value);
	void __fastcall SetRecordSeparatorCustom(AnsiString Value);
	void __fastcall ReplaceHTMLChars(AnsiString &Value);
	virtual bool __fastcall BLOBIsMIME(void);
	TSMIDataType __fastcall GetSMIDataType(Db::TFieldType DataType);
	void __fastcall ParserEvaluate(System::TObject* Sender, AnsiString Eval, const Variant * Args, const 
		int Args_Size, int ArgCount, Variant &Value, bool &Done);
	AnsiString __fastcall BuildTimeFormat();
	AnsiString __fastcall BuildDTFormat();
	__property TTableTypeImport TableType = {read=FTableType, write=FTableType, default=2};
	
public:
	__fastcall virtual TSMImportBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMImportBaseComponent(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Execute(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* AStream);
	void __fastcall AboutSMI(void);
	#pragma option push -w-inl
	/* virtual class method */ virtual AnsiString __fastcall Extension() { return Extension(__classid(TSMImportBaseComponent)
		); }
	#pragma option pop
	/*         class method */ static AnsiString __fastcall Extension(TMetaClass* vmt);
	#pragma option push -w-inl
	/* virtual class method */ virtual AnsiString __fastcall FillFileFilters() { return FillFileFilters(__classid(TSMImportBaseComponent)
		); }
	#pragma option pop
	/*         class method */ static AnsiString __fastcall FillFileFilters(TMetaClass* vmt);
	virtual void __fastcall DetectAutoMapping(void);
	virtual void __fastcall Columns2Mapping(void);
	void __fastcall LoadSpecification(AnsiString strFileName);
	void __fastcall SaveSpecification(AnsiString SpecName, AnsiString FileName, bool ShowDialog);
	void __fastcall LoadSpecificationFromStream(Classes::TStream* Stream);
	void __fastcall SaveSpecificationToStream(Classes::TStream* Stream, const AnsiString SpecName);
	__property TSMIColumns* Columns = {read=GetColumns};
	__property TSMIFieldDelimiter FieldDelimiter = {read=FFieldDelimiter, write=SetFieldDelimiter, default=2
		};
	__property char FieldDelimiterCustom = {read=FFieldDelimiterCustom, write=SetFieldDelimiterCustom, 
		default=9};
	__property TSMITextQualifier TextQualifier = {read=FTextQualifier, write=SetTextQualifier, default=2
		};
	__property char TextQualifierCustom = {read=FTextQualifierCustom, write=SetTextQualifierCustom, default=34
		};
	__property TSMIRecordSeparator RecordSeparator = {read=FRecordSeparator, write=SetRecordSeparator, 
		default=1};
	__property AnsiString RecordSeparatorCustom = {read=FRecordSeparatorCustom, write=SetRecordSeparatorCustom
		};
	__property AnsiString SourceFileName = {read=FSourceFileName, write=FSourceFileName};
	__property bool Fixed = {read=FFixed, write=FFixed, nodefault};
	__property int RowFirst = {read=FRowFirst, write=FRowFirst, default=1};
	__property int RowLast = {read=FRowLast, write=FRowLast, default=2147483647};
	__property int RowFieldNames = {read=FRowFieldNames, write=FRowFieldNames, default=1};
	
__published:
	__property AnsiString About = {read=FAbout, write=SetAbout};
	__property bool AbortOnProblem = {read=FAbortOnProblem, write=FAbortOnProblem, nodefault};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, nodefault};
	__property TSMICharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, default=0};
	__property TSMIDataFormats* DataFormats = {read=FDataFormats, write=FDataFormats};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property AnsiString DatasetKeys = {read=FDatasetKeys, write=FDatasetKeys};
	__property TSMILoadCondition* LoadCondition = {read=FLoadCondition, write=SetLoadCondition};
	__property Classes::TStrings* Mappings = {read=FMappings, write=SetMappings};
	__property TImportMode Mode = {read=FMode, write=FMode, default=0};
	__property TSMIOptions Options = {read=FOptions, write=FOptions, default=31};
	__property AnsiString TitleStatus = {read=FTitleStatus, write=FTitleStatus};
	__property TSMIStatistic* Statistic = {read=FStatistic, write=FStatistic};
	__property AnsiString SpecificationDir = {read=FSpecificationDir, write=FSpecificationDir};
	__property bool UseDisplayNames = {read=FUseDisplayNames, write=FUseDisplayNames, nodefault};
	__property TSMITrimSpaces TrimSpaces = {read=FTrimSpaces, write=FTrimSpaces, default=0};
	__property TErrorEvent OnErrorEvent = {read=FOnErrorEvent, write=FOnErrorEvent};
	__property TGetCellParamsEvent OnGetCellParams = {read=FOnGetCellParams, write=FOnGetCellParams};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
		
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property TBeforeRecordEvent OnBeforeRecordEvent = {read=FOnBeforeRecordEvent, write=FOnBeforeRecordEvent
		};
	__property TAfterRecordEvent OnAfterRecordEvent = {read=FOnAfterRecordEvent, write=FOnAfterRecordEvent
		};
	__property Classes::TNotifyEvent OnBeforeUpdate = {read=FOnBeforeUpdate, write=FOnBeforeUpdate};
	__property TBeforeFieldEvent OnBeforeFieldUpdate = {read=FOnBeforeFieldUpdate, write=FOnBeforeFieldUpdate
		};
	__property TSMISpecificationEvent OnBeforeLoadSpecification = {read=FOnBeforeLoadSpecification, write=
		FOnBeforeLoadSpecification};
	__property TSMISpecificationEvent OnAfterLoadSpecification = {read=FOnAfterLoadSpecification, write=
		FOnAfterLoadSpecification};
	__property TSMISpecificationEvent OnBeforeSaveSpecification = {read=FOnBeforeSaveSpecification, write=
		FOnBeforeSaveSpecification};
	__property TSMISpecificationEvent OnAfterSaveSpecification = {read=FOnAfterSaveSpecification, write=
		FOnAfterSaveSpecification};
	__property TLocateRecordEvent OnLocateRecord = {read=FOnLocateRecord, write=FOnLocateRecord};
	__property TSMIOnCreateStructure OnCreateStructure = {read=FOnCreateStructure, write=FOnCreateStructure
		};
};

#pragma pack(pop)

typedef void __fastcall (*TPreviewCallback)(System::TObject* grid, int intColumnCount, int intRecNo, 
	bool IsASCII, const Variant &Value);

typedef void __fastcall (*TProgressPreviewCallback)(int Position, int TotalSize);

//-- var, const, procedure ---------------------------------------------------
#define SMIVersion "2.06"
static const int MaxRowValue = 0x7fffffff;
extern PACKAGE void __fastcall AboutSMImport(void);
extern PACKAGE System::ShortString __fastcall GetDefExt(int intIndex);
extern PACKAGE AnsiString __fastcall UECode(bool DOSToWin, AnsiString St);
extern PACKAGE TImportFormatTypes __fastcall GetAvailableImportFormats(void);

}	/* namespace Smibase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smibase;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMIBase
