unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    pnlTop: TPanel;
    btnLoadXLS: TButton;
    Label1: TLabel;
    edFileName: TEdit;
    PageControl1: TPageControl;
    procedure btnLoadXLSClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses SMCells, SMXLS;

procedure TForm1.btnLoadXLSClick(Sender: TObject);
var
  i, j, k: Integer;
  tab: TTabSheet;
  grid: TStringGrid;
  sheet: TSpreadSheet;
  Value: Variant;
begin
  {destroy all tabs/grids for previous loaded wordbook}
  for i := PageControl1.PageCount-1 downto 0 do
    PageControl1.Pages[i].Free;

  with TMSExcel.Create(Self) do
    try
      LoadFromFile(edFileName.Text);

      for k := 0 to Sheets.Count-1 do
      begin
        sheet := Sheets.SpreadSheet(k);
        if Assigned(sheet) then
        begin
          {create a tab and grid for each sheet in workbook}
          tab := TTabSheet.Create(PageControl1);
          tab.Caption := sheet.Caption;
          tab.PageControl := PageControl1;

          grid := TStringGrid.Create(tab);
          grid.DefaultRowHeight := 21;
          grid.Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goRangeSelect, goColSizing];
          grid.Parent := tab;
          grid.Align := alClient;

          grid.RowCount := sheet.Cells.UsedRowCount+1;
          grid.ColCount := sheet.Cells.UsedColCount+1;

          for i := 1 to sheet.Cells.UsedRowCount+1 do
          begin
              for j := 1 to sheet.Cells.UsedColCount+1 do
              begin
                Value := sheet.Cells.GetValue(j-1, i-1);
                if (VarType(Value) = varBoolean) then
                begin
                  if Value then
                    grid.Cells[j, i] := 'True'
                  else
                    grid.Cells[j, i] := 'False'
                end
                else
                  grid.Cells[j, i] := VarToStr(Value);
              end;
          end;

          for i := 1 to grid.RowCount-1 do
            grid.Cells[0, i] := IntToStr(i);
          for j := 1 to grid.ColCount-1 do
            grid.Cells[j, 0] := Chr(Ord('A') + j - 1);
        end
      end
    finally
      Free
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  edFileName.Text := ExtractFilePath(Application.ExeName) + edFileName.Text;
end;

end.
